package foo.bar.client.local;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.common.client.api.RemoteCallback;
import org.jboss.errai.ioc.client.api.EntryPoint;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;

import foo.bar.client.shared.MyRemoteInterface;

/**
 * Main application entry point.
 */
@EntryPoint
public class App {

    private final Label responseLabel = new Label();
    private final Button button = new Button("Send");

    @Inject
    private Caller<MyRemoteInterface> myRemote;
    
    @Inject
    private StringValue value;
    
    @PostConstruct
    public void buildUI() {

        button.addClickHandler(new ClickHandler() {
            @Override
            public void onClick(ClickEvent event) {

                // In GWT Dev Mode, Text written to System.out shows up in the
                // console where you launched Dev Mode (eg. in your terminal
                // window or in the Eclipse Console tab).
                // In Production Mode, System.out is a black hole.
                System.out.println("Handling click event!");

                fireMessage();
            }
        });

        HorizontalPanel horizontalPanel = new HorizontalPanel();
        horizontalPanel.add(button);
        horizontalPanel.add(responseLabel);

        RootPanel.get().add(horizontalPanel);
        
        System.out.println("UI Constructed!");
    }

    /**
     * Fires a CDI HelloMessage with the current contents of the message textbox.
     */
    void fireMessage() {
      myRemote.call(new RemoteCallback<String>() {

        @Override
        public void callback(String response) {
          responseLabel.setText(response);
        }
        
      }).sayHello(value.getValue());
      
      
    }
}